$(document).ready(async function () {
  componenteFiltro('ordemCompra', true, true, 'NumeroConsulta')
  componenteFiltro('fornecedor', true, true, 'FornecedorConsulta')
  componenteFiltro('centroCusto', true, true, 'CentroCustoConsulta')
  componenteFiltro('tipo', true, true, 'TipoConsulta')

  $('#btnConsultarConsulta').on('click', function () {
    ModalConsultaComprasBloqueadas.consultar()
    $('#modalFiltrosConsulta').modal('hide')
  })

  $('#modalConsulta').on('shown.bs.modal', function () {
    PerfilCompras.preencherFiltrosPerfilCompras('Consulta').then((result) => {
      if (!result) {
        return
      }
      ModalConsultaComprasBloqueadas.consultar()
    })
  })

  $('#btnFiltrosModalConsulta').on('click', function () {
    $('#modalFiltrosConsulta').modal('show')
  })

  $('#btnFiltrosConsulta').on('click', function () {
    $('#modalFiltrosConsulta').modal('show')
  })

  $('#btnLimparFiltrosConsulta').on('click', function () {
    limparFiltros()
  })

  function limparFiltros() {
    $('#txtNumeroConsulta').empty().trigger('change')
    $('#txtFornecedorConsulta').empty().trigger('change')
    if (!$('#txtTipoConsulta').prop('disabled')) {
      $('#txtTipoConsulta').empty().trigger('change')
    }
    if (!$('#txtCentroCustoConsulta').prop('disabled')) {
      $('#txtCentroCustoConsulta').empty().trigger('change')
    }
    $('#txtEmissaoDeConsulta').val('1200-01-01')
    $('#txtEmissaoAteConsulta').val('2500-12-31')
    $('#txtEntregaDeConsulta').val('1200-01-01')
    $('#txtEntregaAteConsulta').val('2500-12-31')
  }

  $('#tabelaItensConsulta').on('click', '#btnCotacao', async function () {
    const datatableItens = $('#tabelaItensConsulta').DataTable()
    const dados = datatableItens?.row($(this)?.parents('tr'))?.data()
    const dadosCotacao = await ModalCotacao.buscarDados(dados.numero, dados.fornecedor)
    ModalCotacao.carregar({ dadosCotacao, fornecedorAprovado: dados.fornecedor, ordemCompra: dados.numero })
  })

  $('#tabelaItensConsulta').on('click', '#btnImprimir', async function () {
    const datatableItens = $('#tabelaItensConsulta').DataTable()
    const dados = datatableItens?.row($(this)?.parents('tr'))?.data()
    ComprasBloqueadas.imprimir({ numero: dados.numero })
  })
})

window.ModalConsultaComprasBloqueadas = window.ModalConsultaComprasBloqueadas || {}

ModalConsultaComprasBloqueadas.criarTabelaItens = ({ filtros }) => {
  if ($.fn.DataTable.isDataTable('#tabelaItensConsulta')) {
    $('#tabelaItensConsulta').DataTable().destroy()
    $('#tabelaItensConsulta').empty()
  }

  const columns = [
    {
      data: 'numero',
      title: 'Número',
      render: (data) => (
        '<div style="text-align:start;"> ' +
        '    <button class="btn btn-info btn-sm dropdown-toggle btnVerificaOpcoes" id="tutorialTabela" type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false"> ' +
        '      ' + data + ' ' +
        '    </button> ' +
        '    <div class="dropdown-menu"> ' +
        '    <button class="dropdown-item" type="button" title="Cotação" id="btnCotacao">Cotação</button>     ' +
        '    <button class="dropdown-item" type="button" title="Imprimir" id="btnImprimir">Imprimir</button>     ' +
        '</div>'
      )
    },
    {
      data: 'status',
      title: 'Status',
    },
    {
      data: 'usuario',
      title: 'Usuário',
    },
    {
      data: 'aprovadorPendente',
      title: 'Aprovador Pendente',
    },
    {
      data: 'dataEmissao',
      title: 'Emissão',
      render: function (data) {
        return retornarDataISOEmYMD({ dataISO: data, usarUTC: true, reverso: true, separadorData: '/' })
      }
    },
    {
      data: 'dataEntrega',
      title: 'Entrega',
      render: function (data) {
        return retornarDataISOEmYMD({ dataISO: data, usarUTC: true, reverso: true, separadorData: '/' })
      }
    },
    {
      data: 'fornecedor',
      title: 'Fornecedor',
    },
    {
      data: 'nomeFornecedor',
      title: 'Nome',
    },
    {
      data: 'colecao',
      title: 'Coleção',
    },
    {
      data: 'descricaoColecao',
      title: 'Desc. Coleção',
    },
    {
      data: 'motivo',
      title: 'Motivo',
    },
    {
      data: 'descricaoMotivo',
      title: 'Desc. Motivo',
    },
    {
      data: 'centroCusto',
      title: 'Centro de Custo',
    },
    {
      data: 'descricaoCentroCusto',
      title: 'Desc. Centro de Custo',
    },
    {
      data: 'tipo',
      title: 'Tipo',
      render: function (data) {
        if (data === 0) {
          return ''
        }

        return data
      }
    },
    {
      data: 'descricaoTipo',
      title: 'Desc. Tipo',
    },
    {
      data: 'observacao',
      title: 'Observação',
    },
    {
      data: 'id',
      title: 'Id',
      visible: false,
    },
  ]

  $('#tabelaItensConsulta').DataTable({
    sort: false,
    paging: true,
    destroy: true,
    lengthChange: false,
    filter: false,
    info: false,
    ordering: false,
    sorting: false,
    order: false,
    pageLength: 12,
    colReorder: true,
    serverSide: true,
    ajax: {
      url: `${getCookie('protocolo')}://${getCookie('ip_api')}/sisplan/centralcompras/compra/v1/bloqueadasporperfil`,
      type: "POST",
      headers: {
        'Authorization': getCookie('accessToken') ? 'Bearer ' + getCookie('accessToken') : '',
      },
      data: function (data) {
        const { start, length, draw } = data;
        return JSON.stringify({
          filtros,
          paginacao: {
            quantidadeMaximaRegistros: length,
            quantidadeRegistrosPular: start,
            contadorRequisicoes: draw,
          },
          empresa: getCookie('empresa'),
          idUsuario: getCookie('id_usuario'),
        })
      },
      dataSrc: function (json) {
        if (!json || !json.data) {
          return []
        }
        return json.data
      },
      cache: true,
      beforeSend: function () {
        $.LoadingOverlay('show')
      },
      complete: function () {
        $.LoadingOverlay('hide')
      },
    },
    autoWidth: true,
    columns,
    scrollX: true,
    scrollY: '55vh',
  })
  // UtilsCentralCompras.criarContainerBotoes({
  //   tabela: 'tabelaItensConsulta',
  // })
  // UtilsCentralCompras.habilitarEsconderColunasItensSolicitacao({
  //   tabela: 'tabelaItensConsulta',
  //   tela: 'ModalConsultaComprasBloqueadas',
  // })
  // UtilsCentralCompras.habilitarExportarCsv({
  //   tabela: 'tabelaItensConsulta',
  //   status: 'B',
  //   tipo: 'COM',
  //   modalConsulta: true,
  //   retornarFiltros: ModalConsultaComprasBloqueadas.retornarFiltros,
  // })
}

ModalConsultaComprasBloqueadas.retornarFiltros = async function () {
  const emissaoDe = $('#txtEmissaoDeConsulta').val() || '1200-01-01'
  const emissaoAte = $('#txtEmissaoAteConsulta').val() || '1200-01-01'
  const entregaDe = $('#txtEntregaDeConsulta').val() || '1200-01-01'
  const entregaAte = $('#txtEntregaAteConsulta').val() || '1200-01-01'
  const numero = await formataListas($('#txtNumeroConsulta').val().toString())
  const fornecedor = await formataListas($('#txtFornecedorConsulta').val().toString())
  const tipo = await formataListas($('#txtTipoConsulta').val().toString(), true)
  const centroCusto = await formataListas($('#txtCentroCustoConsulta').val().toString())

  return {
    emissaoDe,
    emissaoAte,
    entregaDe,
    entregaAte,
    numero,
    fornecedor,
    tipo,
    centroCusto,
  }
}

ModalConsultaComprasBloqueadas.consultar = function () {
  ModalConsultaComprasBloqueadas.retornarFiltros()
    .then((filtros) => {
      ModalConsultaComprasBloqueadas.criarTabelaItens({ filtros })
    })
}